#!/bin/bash
#####################################
# Manage du concentrateur VPN
# Mode Dialog
# Avec ou sans PKI
# PreVersion 2
# LB 01/2003 Eole Dijon
# $Id: manage-sphynx.sh,v 1.4 2005/01/13 15:53:09 sam Exp $
#######################################
# Initialisation des variables
# Avec verification dans l'Environnement
RepEole=${RepEole="/usr/share/eole"}
RepIpsec=${RepIpsec=/etc/freeswan}
RepSphynx=${RepSphynx=/usr/share/eole/sphynx-vpn}
LgCle=${LgCle=2048}
PKI=0
NBlignes=10

# Mode Dialog Graphique
ModeDialog=${ModeDialog=oui}
if [ "$ModeDialog" == "oui" ]
then
export DIALOGRC=$RepEole/.dialogrc
export ECHO=InfoBox2
fi
service gpm status >/dev/null
if [ $? -ne 0 ]
then
#	NOMOUSE="--nomouse"
	NOMOUSE=""
fi

TitreGen="Eole  -  Gestion du Sphynx"
# Appel Bibliothèque
[ -x $RepEole/FonctionsEole ] || {
        echo "Pas de bibliotheque Eole !"
        exit 1
	}
. $RepEole/FonctionsEole

Question()
{
InputBox "$1" Rep
if [ "$Rep" == "CANCEL" ] 
then
echo "Abandon"	
exit 1
fi
}

## Mise en place d'un lock

if [ -e /var/lock/manage-sphynx ]
then 
	echo "Une instance de manage-sphynx tourne déjà."
	echo "voulez vous la killer o/n ?"
	read Rep
	if [ "$Rep" == "oui" -o "$Rep" == "o" -o "$Rep" == "O" ]
	then
		rm -f /var/lock/manage-sphynx
		for i in `ps -edf |grep manage-sphynx.sh |awk -F ' ' '{print $2}'`
		do kill -9 $i
		done
		exit 1
	else
		exit 1
	fi
else
	touch /var/lock/manage-sphynx
fi

#OkBox "Manage Base Sphynx\n\nPour Vous Deplacer sur l'Ecran\nUtiliser votre Souris\nOu la touche tabulation.\n\n   Vous pouvez ABANDONNER \nen pressant la touche <Echap>"
#if [ "$?" -eq 255 ]
#then
	#exit 1
#fi
	
FileCfg="$Tmp/Sphynx$TmpSuff"
touch $FileCfg


Rep=""
while [ 1 ]
do
MenuBox "Votre Choix"  Rep "1 Lister_la_base 2 Demander_Certificat 3 Gerer_Reseau_Sphynx 4 Gerer_Amon_Etablissement 5 Recharger_Crls 6 Recharger_RVP 7 Gestion_Connexions 8 Regeneration_conf-Sphynx 9 Regeneration_conf_Amon 10 Admin_Serveur Q Quitter"

if [ "$Rep" == "CANCEL" ] 
then
echo "Abandon"	
rm -f /var/lock/manage-sphynx
exit 1
fi
case $Rep in
	1) 
	$RepSphynx/sphynx -r > $FileCfg
	dialog $NOMOUSE --title "Liste "  --exit-label "Quitter" --textbox $FileCfg 0 0
	;;
	2) 
	/usr/share/eole/init-certif.sh
	sleep 1
	;;
	3) 
	/usr/share/eole/reseau-sphynx.sh
	;;
	4)
	/usr/share/eole/reseau-etablissement.sh
	;;
	5)
	/usr/share/eole/Recup-Crl.sh
        dialog $NOMOUSE --title "Compte-Rendu "  --exit-label "Quitter" --textbox /tmp/RecupCrl.log 0 0
	;;
	6)
	QuestionBox "Relancer IPSEC coupe les connexion en cours\nEtes vous sur ?" Rep
	if [ "$Rep" == "OUI" ] 
	then
	/usr/share/eole/relance-rvp.sh  > $FileCfg 2>&1
        dialog $NOMOUSE --title "Compte-Rendu "  --exit-label "Quitter" --textbox $FileCfg 0 0
	fi
	;;
	7)
	/usr/share/eole/gestion_connexions.sh
	;;
	8)
	QuestionBox "Regenerer la configuration ipsec pour Sphynx\n Attention, cette procedure supprime tous les fichiers de /etc/freeswan et les regenere à partir des templates et de la base xml" Rep
	if [ "$Rep" == "OUI" ] 
	then
		rm -f  $RepSphynx/ipsec/*
		rm -f $RepIpsec/ipsec.conf
		rm -f $RepIpsec/ipsec.secret
		rm -f $RepIpsec/ipsec_updown_*
		$RepSphynx/sphynx -t
		cp -f $RepSphynx/ipsec/ipsec.conf_Sphynx $RepIpsec/ipsec.conf
		cp -f $RepSphynx/ipsec/ipsec.secrets_Sphynx $RepIpsec/ipsec.secrets
		cp -f $RepSphynx/ipsec/ipsec_updown_*-sphynx $RepIpsec/
		ls -l $RepIpsec/ > $FileCfg 2>&1
		dialog $NOMOUSE --title "Compte-Rendu "  --exit-label "Quitter" --textbox $FileCfg 0 0
	fi	
	;;
	9)
        /usr/share/eole/init-amon.sh GenConf
	;;
	10)
	/usr/share/eole/admin-sphynx.sh
	;;
	Q)
	rm -f /var/lock/manage-sphynx
	exit 0
	;;

esac
done
